#!/usr/bin/perl
use Math::Trig;
use CGI qw(:standard);                      #call CGI.pm

$pi = acos(-1);                             #pi
$date = date;
$gnuplot = "gnuplot";
$object = new CGI;                          #create a new CGI object
print_header();                             #call subroutine "print_header"
print_form();                               #call subroutine "form"
if (param())
{
    print_to_logfile();
    print_to_file();                             #print data to log file "inputsR.log" to have an input reference
    &Gnuplot();

#    Simpson();
    Gauss();
    system("convert Simpson3.ps -size 100x200 -rotate 90 Simpson3.jpg");#convert from ps to jpg
    system("chmod a+rw Simpson3.jpg");
    system(" mv Simpson3.jpg /home/simos/public_html/images/ArithmAnal/Integration/");
    return_form();                               #call subroutine return_form
    webtail();
    print $object->end_html();                   #end the html
}

sub print_header
{
    print $object ->header('text/html');                                           #create an http header
    print  $object->start_html('Gauss Integrator',                                          #start the html
			       'kokkotas@astro.auth.gr'),
    $object->h1('This is the Interactive Integrator using Gauss',"'",' method'),               #level 1 header
    $object->startform('POST');
}

sub print_form
{
  print $object->start_form('POST'),
    $object->body('(This is Gauss',"'",' method for calculating integrals. The user provides a function f(x) and the limits of the integral and the method of integration. After pressing the "Calculate it" button, the program plots f(x) and calculates the integral using the Gauss',"'",' method.', $object->b("<font color=blue>", 'All trigonometric functions are supported. Powers must be entered using **, for example x^2 must be entered as x**2. The natural logarithm o x must be entered as log(x). In function f(x), it is suggested to put a space before and after each x.', $object->b(" <font color=black>", ' For questions or to report problems please contact: simos@astro.auth.gr )'))),
  $object->p,
  $object->body('*Please give your name: '),
  $object->textfield('name','guest','20','20'),                                #create a text field
  $object->p,
  $object->body('Please give a function f(x) = '),
  $object->textfield('function','sin(x)','30','40'), 
  $object->p,
  $object->body('Please give x minimum x<sub>min </sub> = '),
  $object->textfield('x_min','0','20','20'),
  $object->br,
  $object->body('Please give x maximum x<sub>max </sub>= '),
  $object->textfield('x_max','10','20','20'),
  $object->p;

  
  $method = $object->param('methods');
  $name = $object->param('name');
  $function = $object->param('function');
  $funct = $function;
  $y = '$x';
  $funct =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($y)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $funct =~ s/\*x/*($y)/gi;                          #replace *x with *($x)
  $funct =~ s/x\*/($y)*/gi;                          #replace x* with ($x)*
  $funct =~ s/\sx/($y)/gi;                           #replace  x with ($x)
  $funct =~ s/x\s/($y)/gi;                           #replace x  with ($x)
  $funct =~ s/\+x / +($y)/gi;                        #replace +x with +($x)
  $funct =~ s/x\+/($y)+/gi;                          #replace x+ with ($x)+
  $funct =~ s/\-x/-($y)/gi;                          #replace -x with -($x)
  $funct =~ s/x\-/($y)-/gi;                          #replace x- with ($x)

  $x_min = $object->param('x_min');
  $x_max = $object->param('x_max');
  $steps = $object->param('steps');
  $R = $object->param('R');
  print $object->p;
  print $object->submit(-name=>'GO1', -value=>'Calculate it'),                   #submit button
  $object->p;
  print $object->reset('Reset to default values','Reset to default values'),                 #reset button
  $object->p;
  print $object->defaults('Erase everything','Erase everything'),
  $object->p;
  print $object->body(`date`);                                          #print date and time on page
  print $object->end_form();                                            #end the current form 
  print $object->hr;                                                    #print a horisontal line

}


sub print_to_file
  {
    open(DATA,">dataR.dat") || die("Error");
    close(DATA);
    open(DATA1,">>dataR.dat") || die("Error");
    $dx = abs($x_max-$x_min)/100;
    $h = abs($x_max-$x_min)/5;
    $x = $x_min - $dx;
    for ($i=1;$i<=101;$i++)
    {
	$x = $x + $dx;
	$f = eval $funct;
	print DATA1 "$x $f", "\n";
    }
    close(DATA1);
}


sub print_to_logfile
  {
    $server =  $ENV{'SERVER_NAME'};
    $agent =  $ENV{'HTTP_USER_AGENT'}; 
    $ip = $ENV{'REMOTE_ADDR'};  
    open(DATA2,">>inputsR.log") || die;
    print DATA2 " ",`date`;
    print DATA2 " User Data: Name: $name, IP: $ip, Browser: $agent ","\n";
    print DATA2 " User Request: Function: $function, x_min: $x_min, x_max: $x_max ","\n";
    print DATA2 "\n";
    close(DATA2);
  }


sub Gauss
{
    $Int = 0;
#    $dx = abs($x_max-$x_min)/$steps;
    $a = $x_min;
    $b = $x_max;

    $dt = 0.5*($x_max-$x_min);
    
    $x = 0.5*($b-$a)*.86113631 + 0.5*($b-$a);  
    $fx1 = eval $funct; 
    $x = 0.5*($b-$a)*(-.86113631) + 0.5*($b-$a);
    $fx2 = eval $funct; 
    $x = 0.5*($b-$a)*.33948104 + 0.5*($b-$a); 
    $fx3 = eval $funct;
    $x = 0.5*($b-$a)*(-.33948104) + 0.5*($b-$a);
    $fx4 = eval $funct;
    

    $A1 = 0.34785485;
    $A2 = $A1;
    $A3 = 0.652145;
    $A4 = $A3;

    $Int4 = $dt*($A1*$fx1 + $A2*$fx2 + $A3*$fx3 + $A4*$fx4 );
    
    $A1 = 0.10122854;
    $A2 = $A1;
    $A3 = 0.22381034;
    $A4 = $A3;
    $A5 = 0.31370665;
    $A6 = $A5;
    $A7 = 0.36268378;
    $A8 = $A7;

    $x = 0.5*($b-$a)*.96028986 + 0.5*($b-$a);  
    $fx1 = eval $funct; 
    $x = 0.5*($b-$a)*(-.96028986) + 0.5*($b-$a);
    $fx2 = eval $funct; 
    $x = 0.5*($b-$a)*.79666648 + 0.5*($b-$a); 
    $fx3 = eval $funct;
    $x = 0.5*($b-$a)*(-.79666648) + 0.5*($b-$a);
    $fx4 = eval $funct;
    $x = 0.5*($b-$a)*.52553241 + 0.5*($b-$a);  
    $fx5 = eval $funct; 
    $x = 0.5*($b-$a)*(-.52553241) + 0.5*($b-$a);
    $fx6 = eval $funct; 
    $x = 0.5*($b-$a)*.18343464 + 0.5*($b-$a); 
    $fx7 = eval $funct;
    $x = 0.5*($b-$a)*(-.18343464) + 0.5*($b-$a);
    $fx8 = eval $funct;

    $Int8 = $dt*($A1*$fx1 + $A2*$fx2 + $A3*$fx3 + $A4*$fx4 + $A5*$fx5 + $A6*$fx6 + $A7*$fx7 + $A8*$fx8 );

}

sub return_form
  {
    print $object->start_form();
    print $object->body('Your name is:', $object->b("<font color=blue>",$name)),
      $object->p,
	"<font color=black>";
    print $object->body('You have asked to calculate the integral of <font color=blue> f(x) = ', $object->b($function),' <font color=black> in the interval:', $object->b("<font color=blue>",'[',$x_min,',',$x_max,']')),
      $object->p,
	"<font color=black>";
    print $object->body('Here is the plot:'),
      $object->p;
    print $object->img({src=>"http://www.astro.auth.gr/~simos/images/ArithmAnal/Integration/Simpson3.jpg"}),
      $object->p;
    print  $object->b('Gauss with 4 points' ),$object->br;
    print $object->body('The Integral of <font color=blue> f(x) <font color =black> from <font color=blue>', $x_min,' <font color=black> to <font color=blue> ',$x_max,' <font color=black> is:', $object->b("<font color=blue>",'I = ',$Int4));
    
    print $object->p, "<font color=black>";
    print  $object->b('Gauss with 8 points' ),$object->br;
    print $object->body('The Integral of <font color=blue> f(x) <font color =black> from <font color=blue>', $x_min,' <font color=black> to <font color=blue> ',$x_max,' <font color=black> is:', $object->b("<font color=blue>",'I = ',$Int8));
    
  }


sub Gnuplot
  {
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit " The integral is equal to the marked area under the plot "               #the title of the plot
	unset key
	set grid
	set o "Simpson3.ps"                                                           #the name of the plot
	set terminal pos
	set ylabel "f(x)"
	set xlabel "x"
	plot [$x_min-$h:$x_max+$h] "dataR.dat" u 1:2 w filledcurves y1=0 lt -1, $function w l lt 1, 0 w l lt -1
gnuplot_Commands_done
    close(GNUPLOT);
  }









#counts the visits and prints to the webpage
sub webtail
{
    print $object->p,
    $object->hr;
    $countfile = "cgicountR";
    $count = `cat $countfile`;
    chop($count);
    $count = $count + 1;
    open(INF,">$countfile");
    print INF "$count\n";
    close(INF);
    print $object->a({href=>"http://www.astro.auth.gr/~simos/cgi-bin/link.pl"}, 'Back to the Interactive Numerical Analysis page'); 
    print $object->hr;  
    print $object->p;
    #print the counter and contact e-mail address
    print $object->body("<font color = black>", "<font size=1.5>",'This web page has been visited: ',"<font color=red>",$count,"<font color=black>",'times');
    print $object->br;
    print $object->body("<font color=black>","<font size=1.5>",'If you have any comments or questions please contact: ');
    print $object->a({href=>'mailto:simos@astro.auth.gr'},'simos@astro.auth.gr');
    print $object->p;
    print $object->body("<!-- Start of StatCounter Code --><script type='text/javascript' language='javascript'>var sc_project=895250;var sc_invisible=0;var sc_partition=7;var sc_security='ccb97b32';</script><script type='text/javascript' language='javascript' src='http://www.statcounter.com/counter/counter.js'></script><noscript><a href='http://www.statcounter.com/' target='_blank'><img  src='http://c8.statcounter.com/counter.php?sc_project=895250&amp;java=0&amp;security=ccb97b32&amp;invisible=0' alt='web stats' border='0'></a> </noscript>
<!-- End of StatCounter Code -->");
}
