#!/usr/bin/perl 
use Math::Trig;
use CGI qw(:standard);                      #call CGI.pm

$pi = acos(-1);                             #pi
$date = date;
$gnuplot = "gnuplot";
$object = new CGI;                          #create a new CGI object
print_header();                             #call subroutine "print_header"
print_form();                               #call subroutine "form"
if (param())
{
    print_to_file();                             #print data to log file "inputs.log" to have an input reference                       
    Lagrange1();                                  #call subroutine Lagrange to solve the problem and prind the data for plotting
    print_data1();
    Lagrange2();
    print_data2();
    Lagrange3(); 
    print_data3();      
    &Gnuplot();
    system("convert Lagrange1.ps -size 100x200 -rotate 90 Lagrange1.jpg");#convert from ps to jpg
    system("chmod a+rw Lagrange1.jpg");
    system(" mv Lagrange1.jpg /home/simos/public_html/images/ArithmAnal/Lagrange/");
    return_form();                               #call subroutine return_form
    webtail();
    print $object->end_html();                   #end the html
}


###### The following are the required subroutines ######

sub print_header
{
    print $object ->header('text/html');                                           #create an http header
    print  $object->start_html('Lagrange',                                   #start the html
			       'kokkotas@astro.auth.gr'),
    $object->h1('Lagrange Polynomial Approximation'),                              #level 1 header
    $object->startform('POST');
}

sub print_form
{
    print $object->start_form('POST'),
    $object->body('This is the demonstration of the Lagrange polynomial approximation of functions. The user provides a function f(x) and an inteval, while the program calculates the 3rd, 4th and 5th order Lagrange polynomial approximation of f(x) in the given interval. The final output are the plots of the approximations togeather with the plot of the provided function and the points used for every approximation. Fields marked with a star are optional. After pressing the "Approximate f(x)" button, scroll down to see the results.', $object->b("<font color=blue>", 'All trigonometric functions are supported. Powers must be entered using **, for example x^2 must be entered as x**2. The natural logarithm o x must be entered as log(x). In function f(x), it is suggested to put a space before and after each x.', $object->b(" <font color=black>", ' For questions or to report problems please contact: simos@astro.auth.gr'))),
    $object->p,
    $object->body('*Please give your name: '),
    $object->textfield('name','guest','20','20'),                          #create a text field
    $object->p,
    $object->body('Please give a function f(x) = '),
    $object->textfield('function','sin(x)','30','40'), 
    $object->p,
    $object->body('Please give x minimum x<sub>min </sub> = '),
    $object->textfield('x_min','0','20','20'),
    $object->br,
    $object->body('Please give x maximum x<sub>max </sub>= '),
    $object->textfield('x_max','10','20','20');

    $name = $object->param('name');
    $function = $object->param('function');
    $funct = $function;
    $y = '$x';
    $funct =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($y)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
    $funct =~ s/\*x/*($y)/gi;                          #replace *x with *($x)
    $funct =~ s/x\*/($y)*/gi;                          #replace x* with ($x)*
    $funct =~ s/\sx/($y)/gi;                           #replace  x with ($x)
    $funct =~ s/x\s/($y)/gi;                           #replace x  with ($x)
    $funct =~ s/\+x / +($y)/gi;                        #replace +x with +($x)
    $funct =~ s/x\+/($y)+/gi;                          #replace x+ with ($x)+
    $funct =~ s/\-x/-($y)/gi;                          #replace -x with -($x)
    $funct =~ s/x\-/($y)-/gi;                          #replace x- with ($x)

    $x_min = $object->param('x_min');
    $x_max = $object->param('x_max');

    print $object->p;
    print $object->submit(-name=>'GO1', -value=>'Approximate f(x)'),                   #submit button
    $object->p;
    print $object->defaults('Reset to default values','Reset to default values'),                 #defaults button
    $object->p;
    print $object->body(`date`);                                          #print date and time on page
    print $object->end_form();                                            #end the current form 
    print $object->hr;                                                    #print a horisontal line
    
}

sub print_to_file
{
    $server =  $ENV{'SERVER_NAME'};
    $agent =  $ENV{'HTTP_USER_AGENT'}; 
    $ip = $ENV{'REMOTE_ADDR'}; 
    open(LOGFILE,">>inputs1.log") || die("Error1: Cannot open file");
    print LOGFILE " ",`date`;  
    print LOGFILE " User Data: Name: $name, IP: $ip, Browser: $agent ","\n";      
    print LOGFILE " User Request: Function: $function","\n\n";  #print data to log file
    close(LOGFILE);
}

sub print_data1
{
    open(DATAOUT,">dat1.dat")||die("Error2: Cannot open file");
    print DATAOUT "$x0 $f0","\n";
    print DATAOUT "$x1 $f1","\n";
    print DATAOUT "$x2 $f2","\n";
    print DATAOUT "$x3 $f3","\n";
    close(DATAOUT);
}

sub print_data2
{
    open(DATAOUT,">dat2.dat")||die("Error2: Cannot open file");
    print DATAOUT "$x0 $f0","\n";
    print DATAOUT "$x1 $f1","\n";
    print DATAOUT "$x2 $f2","\n";
    print DATAOUT "$x3 $f3","\n";
    print DATAOUT "$x4 $f4","\n";
    close(DATAOUT);
}

sub print_data3
{
    open(DATAOUT,">dat3.dat")||die("Error2: Cannot open file");
    print DATAOUT "$x0 $f0","\n";
    print DATAOUT "$x1 $f1","\n";
    print DATAOUT "$x2 $f2","\n";
    print DATAOUT "$x3 $f3","\n";
    print DATAOUT "$x4 $f4","\n";
    print DATAOUT "$x $f5","\n";
    close(DATAOUT);
}

sub Lagrange1
{
    open(DATAOUT0,">data1.dat")||die;
    close(DATAOUT0);
    open(DATAOUT1,">>data1.dat")||die("Error3: Cannot open file");
    $dx = ($x_max-$x_min)/100;
    $ddx = ($x_max-$x_min)/3;

    $x = $x_min;
    $x0 = $x_min;
    $f0 = eval "$funct";

    $x = $x + $ddx;
    $x1 = $x; 
    $f1 = eval "$funct";

    $x = $x + $ddx;
    $f2 = eval "$funct";
    $x2 = $x; 

    $x = $x + $ddx;
    $x3 = $x;
    $f3 = eval "$funct";

    $x = $x_min - $dx;
 
    for ($i=1;$i<=101;$i++)
    {
	$x = $x + $dx;
	$f =  ($x-$x1)*($x-$x2)*($x-$x3)/(($x0-$x1)*($x0-$x2)*($x0-$x3))*$f0 + ($x-$x0)*($x-$x2)*($x-$x3)/(($x1-$x0)*($x1-$x2)*($x1-$x3))*$f1 + ($x-$x0)*($x-$x1)*($x-$x3)/(($x2-$x0)*($x2-$x1)*($x2-$x3))*$f2 + ($x-$x0)*($x-$x1)*($x-$x2)/(($x3-$x0)*($x3-$x1)*($x3-$x2))*$f3; 
	print DATAOUT1 "$x $f","\n";
    }
    close(DATAOUT1);
}

sub Lagrange2
{
    open(DATA,">data2.dat")||die;
    close(DATA);
    open(DATA1,">>data2.dat")||die("Error3: Cannot open file");
    $dx = ($x_max-$x_min)/100;
    $ddx = ($x_max-$x_min)/4;

    $x = $x_min;
    $x0 = $x_min;
    $f0 = eval "$funct";

    $x = $x + $ddx;
    $x1 = $x; 
    $f1 = eval "$funct";

    $x = $x + $ddx;
    $f2 = eval "$funct";
    $x2 = $x; 

    $x = $x + $ddx;
    $x3 = $x;
    $f3 = eval "$funct";

    $x = $x + $ddx;
    $x4 = $x;
    $f4 = eval "$funct";

    $x = $x_min - $dx;
 
    for ($k=1;$k<=101;$k++)
    {
	$x = $x + $dx;
	$f =  ($x-$x1)*($x-$x2)*($x-$x3)*($x-$x4)/(($x0-$x1)*($x0-$x2)*($x0-$x3)*($x0-$x4))*$f0 + ($x-$x0)*($x-$x2)*($x-$x3)*($x-$x4)/(($x1-$x0)*($x1-$x2)*($x1-$x3)*($x1-$x4))*$f1 + ($x-$x0)*($x-$x1)*($x-$x3)*($x-$x4)/(($x2-$x0)*($x2-$x1)*($x2-$x3)*($x2-$x4))*$f2 + ($x-$x0)*($x-$x1)*($x-$x2)*($x-$x4)/(($x3-$x0)*($x3-$x1)*($x3-$x2)*($x3-$x4))*$f3 + ($x-$x0)*($x-$x1)*($x-$x2)*($x-$x3)/(($x4-$x0)*($x4-$x1)*($x4-$x2)*($x4-$x3))*$f4; 
	print DATA1 "$x $f","\n";
    }
    close(DATA1);
}

sub Lagrange3
{
    open(DAT,">data3.dat")||die;
    close(DAT);
    open(DATA2,">>data3.dat")||die("Error3: Cannot open file");
    $dx = ($x_max-$x_min)/100;
    $ddx = ($x_max-$x_min)/5;

    $x = $x_min;
    $x0 = $x_min;
    $f0 = eval "$funct";

    $x = $x + $ddx;
    $x1 = $x; 
    $f1 = eval "$funct";

    $x = $x + $ddx;
    $f2 = eval "$funct";
    $x2 = $x; 

    $x = $x + $ddx;
    $x3 = $x;
    $f3 = eval "$funct";

    $x = $x + $ddx;
    $x4 = $x;
    $f4 = eval "$funct";
    
    $x = $x + $ddx;
    $x5 = $x;
    $f5 = eval "$funct";

    $x = $x_min-$dx;
 
    for ($j=1;$j<=101;$j++)
    {
	$x = $x + $dx;
	$f = ($x-$x1)*($x-$x2)*($x-$x3)*($x-$x4)*($x-$x5)/(($x0-$x1)*($x0-$x2)*($x0-$x3)*($x0-$x4)*($x0-$x5))*$f0 + ($x-$x0)*($x-$x2)*($x-$x3)*($x-$x4)*($x-$x5)/(($x1-$x0)*($x1-$x2)*($x1-$x3)*($x1-$x4)*($x1-$x5))*$f1 + ($x-$x0)*($x-$x1)*($x-$x3)*($x-$x4)*($x-$x5)/(($x2-$x0)*($x2-$x1)*($x2-$x3)*($x2-$x4)*($x2-$x5))*$f2 + ($x-$x0)*($x-$x1)*($x-$x2)*($x-$x4)*($x-$x5)/(($x3-$x0)*($x3-$x1)*($x3-$x2)*($x3-$x4)*($x3-$x5))*$f3 + ($x-$x0)*($x-$x1)*($x-$x2)*($x-$x3)*($x-$x5)/(($x4-$x0)*($x4-$x1)*($x4-$x2)*($x4-$x3)*($x4-$x5))*$f4 + ($x-$x0)*($x-$x1)*($x-$x2)*($x-$x3)*($x-$x4)/(($x5-$x0)*($x5-$x1)*($x5-$x2)*($x5-$x3)*($x5-$x4))*$f5; 
	print DATA2 "$x $f","\n";
    }
    close(DATA2);
}


sub return_form
{
    print $object->start_form();
    print $object->body('Your name is:', $object->b("<font color=blue>",$name)),
    $object->p,
    "<font color=black>";
    print $object->body('You gave function: ', $object->b("<font color=blue>",$function)),
    $object->p,
    "<font color=black>";
    print $object->body('You gave interval:', $object->b("<font color=blue>",'[',$x_min,',',$x_max,']')),
    $object->p,
    "<font color=black>";
    print $object->body('Here is the plot:'),
    $object->p;
    print $object->img({src=>"http://www.astro.auth.gr/~simos/images/ArithmAnal/Lagrange/Lagrange1.jpg"}),
    $object->p,
    $object->body('The',$object->b('black'),' curve represents the function f(x)'),
    $object->br,
    $object->body('The', $object->b("<font color=green>",'green'), "<font color=black>", 'curve represents the ', $object->b('3rd'),' order Lagrange polynomial approximation of f(x).'),
    $object->br,
    $object->body('The', $object->b("<font color=blue>",'blue'), "<font color=black>",'curve represents the ', $object->b('4th'),' order Lagrange polynomial approximation of f(x)'),
    $object->br,
    $object->body('The', $object->b("<font color=red>",'red'), "<font color=black>",'curve represents the ', $object->b('5th'),' order Lagrange polynomial approximation of f(x)');

}


sub Gnuplot
{
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit " Lagrange polynomial approximation of the given function "               #the title of the plot
	unset key
	set grid
	set o "Lagrange1.ps"                                                         #the name of the plot
	set terminal pos color
	set ylabel "f(x)"
	set xlabel "x"
	plot [$x_min:$x_max] $function lt -1, "data1.dat" u 1:2 w l lt 2, "data2.dat" u 1:2 w l lt 3, "data3.dat" u 1:2  w l lt 1, "dat3.dat" u 1:2 w p ps 3 lt 1 pt 3, "dat2.dat" u 1:2 w p ps 3 lt 3 pt 2, "dat1.dat" u 1:2 w p ps 3 lt 2 pt 5
gnuplot_Commands_done
	close(GNUPLOT);
}

#counts the visits and prints to the webpage
sub webtail
{
    print $object->p,
    $object->hr;
    $countfile = "cgicount1";
    $count = `cat $countfile`;
    chop($count);
    $count = $count + 1;
    open(INF,">$countfile");
    print INF "$count\n";
    close(INF);
    print $object->a({href=>"http://www.astro.auth.gr/~simos/cgi-bin/link.pl"}, 'Back to the Interactive Numerical Analysis page'); 
    print $object->hr;  
    print $object->p;
    #print the counter and contact e-mail address
    print $object->body("<font color = black>", "<font size=1.5>",'This web page has been visited: ',"<font color=red>",$count,"<font color=black>",'times');
    print $object->br;
    print $object->body("<font color=black>","<font size=1.5>",'If you have any comments or questions please contact: ');
    print $object->a({href=>'mailto:simos@astro.auth.gr'},'simos@astro.auth.gr');
    print $object->p;
    print $object->body("<!-- Start of StatCounter Code --><script type='text/javascript' language='javascript'>var sc_project=895263;var sc_invisible=0;var sc_partition=7;var sc_security='c081e133';</script><script type='text/javascript' language='javascript' src='http://www.statcounter.com/counter/counter.js'></script><noscript><a href='http://www.statcounter.com/' target='_blank'><img  src='http://c8.statcounter.com/counter.php?sc_project=895263&amp;java=0&amp;security=c081e133&amp;invisible=0' alt='website statistics' border='0'></a> </noscript>
<!-- End of StatCounter Code -->");
}
