#!/usr/bin/perl 
use Math::Trig;
use CGI qw(:standard);                      #call CGI.pm

$pi = acos(-1);                             #pi
$date = date;
$gnuplot = "gnuplot";
$object = new CGI;                          #create a new CGI object
print_header();                             #call subroutine "print_header"
print_form();                               #call subroutine "form"
if (param())
{
    print_to_file();                             #print data to log file "inputs.log" to have an input reference
    print_function();                            #print finction to file for reading by NR.pl
    nr();                                        #call subroutine nr
    &Gnuplot();                                  #call subroutine Gnuplot
    system("convert function1.ps -size 100x200 -rotate 90 function1.jpg");#convert from ps to jpg
    system("chmod a+rw function1.jpg");
    system(" mv function1.jpg /home/simos/public_html/images/ArithmAnal/NR/ ");
    return_form();                               #call subroutine return_form
    print $object->end_html();                   #end the html
}

###### The following are the required subroutines ######

sub print_header
{
    print $object ->header('text/html');                                           #create an http header
    print  $object->start_html('Online Interactive Newton-Raphson Method',                                   #start the html
			       'kokkotas@astro.auth.gr'),
    $object->h1('Online Interactive Newton-Raphson Method for finding roots of functions'),                                                 #level 1 header
  
    $object->startform('POST');
}

#Creates the form
sub print_form
{
    print $object->start_form('POST'),
    $object->body('This is an interactive demonstration of the Newton-Raphson root-finding method. It is recommented that you first run the program using the default values in order to see a working example. Fields marked with a star are optional. After pressing the "Solve f(x) = 0" button, scroll down to see the results. Hit Refresh, if the output does not change after changes in the input. ', $object->b("<font color=blue>", 'All trigonometric functions are supported. Powers must be entered using **, for example x^2 must be entered as x**2. The natural logarithm o x must be entered as log(x). In function f(x), it is suggested to put a space before and after each x.', $object->b(" <font color=black>", ' For questions or to report problems please contact: simos@astro.auth.gr'))),
    $object->p,
    $object->body('*Please give your name: '),
    $object->textfield('name','guest','50','50'),                          #create a text field
    $object->p,
    $object->body('Please give function f(x) = '),
    $object->textfield('function',                                         #create a text field
		       'sin(x)','100','100'),
    $object->br,
    $object->body(' (Use x as the parameter. If you want to use power you can write x followed by ** and the exponential, for example x**2 is x squared. log(x) is the natural logarithm of x)'),
    $object->p;                                                            #paragraph
    $name = $object->param('name');                                        #get input and put it in "name"
    $function = $object->param('function');                                #get input and put it in "function"
    
    print $object->body('*Please give interval where f(x) is valid: '),
    $object->textfield('space','[0:2*pi]'),                               #create a textfield
    $object->br,
    $object->body(' (This is optional. It only affects the limits of the plot. Leave blank to let gnuplot to adjust the limits. Use format [a:b] if you want to limit the plot from a to b)'),
    $object->p;
    $space = $object->param('space');                                     #get input and put it in "space"
    
    print $object->body('Please give a starting point inside the previous space: '),
    $object->textfield('point','2'),
    $object->p;
    $point = $object->param('point');
    
    $point = $object->param('point');
    
    print $object->body('Please choose one of the root-finding methods: ');
    print $object->popup_menu('methods',['Newton-Raphson'],'Newton-Raphson'),
                                                                          #create pop-up menu
    $object->br;
    print $object->body('(Only Newton-Raphson method works temporarily)'),
    $object->p;
    $method = $object->param('methods');
    
    print $object->submit(-name=>'GO1', -value=>'Solve f(x) = 0'),                   #submit button
    $object->p;
    print $object->defaults('Reset to default values','Reset to default values'),#defaults button
	$object->p;
    print $object->body(`date`);                                          #print date and time on page
    print $object->end_form();                                            #end the current form 
    print $object->hr;                                                    #print a horisontal line
}


sub print_to_file
{
    $server =  $ENV{'SERVER_NAME'};
    $agent =  $ENV{'HTTP_USER_AGENT'}; 
    $ip = $ENV{'REMOTE_ADDR'}; 
    open(LOGFILE,">>inputs.log") || die("Error1: Cannot open file");
    print LOGFILE " ",`date`;                                                   #print date and time on log file
    print LOGFILE " User Data: Name: $name, IP: $ip, Browser: $agent ","\n";
    print LOGFILE " User Request: Function: $function, Space: $space","\n\n";
#  print LOGFILE " User: $name, Function: $function, Space:  $space ","\n\n";  #print data on log file
    close(LOGFILE);
}

sub print_function
{
    open (OUTFUNCTION,">function.in") || die("Error2: Cannot open file"); 
    print OUTFUNCTION "$function", "\n";
    print OUTFUNCTION $point;
    close(OUTFUNCTION);
}

#Solves f(x) = 0 using Newton-Raphson
sub nr
{
    system("./NR.pl");

#checkers
    open(ERROR,"error.dat")||die;
    read(ERROR,$check,10);
    close(ERROR);
    if ($check==1)                                                          #check if more than 10 steps needed to find root
    {
	print $object->body("More than 10 steps needed to approach the root"),
	$object->p,
	$object->body("Please try again using another starting point. Here is the plot of f(x) in the given interval: ");
	&Gnuplot1();                                                         #call subroutine Gnuplot1
	print $object->img({src=>"function.jpg"});
	print $object->end_form();
	print $object->hr;                                                  #print a horisontal line
	
	webtail();                                                          #call subroutine webtail to print counter and contact info
	print $object->end_html();                   #end the html
	die;
    } 

    open(ERROR1,"error1.dat")||die;
    read(ERROR1,$check1,10);
    close(ERROR1);
    if ($check1==0)
    {
	print $object->body('Illegal division by zero at the given point'),
	$object->p,
	$object->body('Please try again giving a different starting point'),
	$object->p;
	webtail();
	die;	
    }
    open(ERROR2,"error2.dat")||die;
    read(ERROR2,$check2,10);
    close(ERROR2);
    if ($check2==0)
    {
	print $object->body('The derivative approached zero at some iteration and Newton-Raphson crashed'), 
	    $object->br,
	    $object->body('Please try again giving another starting point'),
	    $object->p,
	    $object->body('Here is the plot of f(x) at the given interval ');
	&Gnuplot1();
        system("convert function.ps function.jpg");#convert from ps to jpg	
	print $object->img({src=>"function.jpg"});
	print $object->end_form();
	print $object->hr;                                                  #print a horisontal line
	
	webtail();                                                          #call subroutine webtail to print counter and contact info
	print $object->end_html();                   #end the html
	die;
    }

}

#prints the output after pressing the submit button
sub return_form
{
    open (PLOT,"data2.plot") || die;
    @data = <PLOT>;
    $steps = @data;
    close(PLOT);
    $xi = @data[$steps-1];

    print $object->start_form();
        
    print $object->body('You gave function: ', $object->b("<font color=blue>",$function)),
    $object->p,
    "<font color=black>";
    print $object->body('You gave space:',  $object->b("<font color=blue>",$space)),
    $object->p,
    "<font color=black>",
    $object->body('You asked for method:',  $object->b("<font color=blue>",$method)),
    $object->p,
    "<font color=black>",
    $object->body('You gave starting point:',  $object->b("<font color=blue>",$point)),
    $object->p,
    "<font color=black>",
    $object->body('The root is:', $object->b("<font color=blue>",$xi)),
    $object->p,
    "<font color=black>",
    $object->body('Number of steps required:', $object->b("<font color=blue>",$steps-1)),
    $object->p,
    "<font color=black>",
    $object->body('Here is the plot of f(x) in the given interval:');
    print $object->p;
    print $object->img({src=>"http://www.astro.auth.gr/~simos/images/ArithmAnal/NR/function1.jpg"});
    print $object->p;	
    print $object->end_form();
    for ($nn=0;$nn<$steps;$nn++)
    {
	print $object->body("<font color=black>",'Step ', $nn, ':', "<font color=blue>", 'x<sub>',$nn,'</sub> =',  $object->b(@data[$nn])),
	$object->p;
    }
    print $object->hr;                                                  #print a horisontal line
    webtail();
}

#plots if f(x) is solved 
sub Gnuplot
{
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit "$name 's plot"                                                          #the title of the plot
	unset key
	set grid
	set o "function1.ps"                                                         #the name of the plot
	set terminal pos color
	set ylabel "f(x)"
	set xlabel "x"
	plot $space $function, 0 lt 3,"data.plot" u 2:3 pt 2 ps 2 lt -1, "data1.plot" every 2 u 1:2 w p pt 1 ps 3 lt -1,"data1.plot" u 1:2:3:4 w vectors lt -1   
gnuplot_Commands_done
	close(GNUPLOT);
}

#plots if f(x) not solved
sub Gnuplot1
{
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit "$name 's plot"                                                          #the title of the plot
	unset key
	set grid
	set o "function.ps"                                                         #the name of the plot
	set terminal pos color
	set ylabel "f(x)"
	set xlabel "x"
	plot $space $function, 0 lt 3
gnuplot_Commands_done
	close(GNUPLOT);
}

#counts the visits and prints to the webpage
sub webtail
{
    $countfile = "cgicount";
    $count = `cat $countfile`;
    chop($count);
    $count = $count + 1;
    open(INF,">$countfile");
    print INF "$count\n";
    close(INF);
#    print $object->a({href=>"http://www.astro.auth.gr/~simos/cgi-bin/link.pl"}, 'Back to the Interactive Numerical Analysis page'); 
#    print $object->hr;  
#    print $object->p;
    #print the counter and contact e-mail address
    print $object->body("<font color = black>", "<font size=1.5>",'This web page has been visited: ',"<font color=red>",$count,"<font color=black>",'times');
    print $object->br;
    print $object->body("<font color=black>","<font size=1.5>",'If you have any comments or questions please contact: ');
    print $object->body(" <!-- Start of StatCounter Code --><script type='text/javascript' language='javascript'>var sc_project=893126;var sc_invisible=0;var sc_partition=7; var sc_security='676ef0b1'; </script><script type='text/javascript' language='javascript' src='http://www.statcounter.com/counter/counter.js'></script><noscript><a href='http://www.statcounter.com/' target='_blank'><img src='http://c8.statcounter.com/counter.php?sc_project=893126&amp;java=0&amp;security=676ef0b1&amp;invisible=0' alt='hit tracker' border='0'></a> </noscript> <!-- End of StatCounter Code -->");
}
