#!/usr/bin/perl

use Math::Trig;
use CGI qw(:standard);
                      #call CGI.pm
alarm(200);

$pi = acos(-1);                             #pi
$date = date;
$gnuplot = "gnuplot";
$object = new CGI;                          #create a new CGI object
print_header();                             #call subroutine "print_header"
print_form();                               #call subroutine "form"

$counter = 0;
if (param())
  {
    #  print $object->body('Please wait...');
    #    print_to_logfile();
    #    print_to_file();                             #print data to log file "inputsR.log" to have an input reference
    if($points >50)
      {
	print $object->b('Too many grid points! Please try again with n<51.'), $object->end_form(),$object->end_html;
	die;
      }
    grid();
    if($xpoints>60)
      {
	print $object->b('Too many grid points at the x direction!(n=',$xpoints,'). Please try again with different boundaries and/or n. For simplicity use a square grid.'), $object->end_form(),$object->end_html;
	die;
      }
    if($ypoints>60)
      {
	print $object->b('Too many grid points at the y direction! (n=',$ypoints,'). Please try again with different boundaries and/or n. For simplicity use a square grid.'), $object->end_form(),$object->end_html;
	die;
      }

    pde_solver();
    Gnuplot_plegma();
    Gnuplot_3dplegma();
    Gnuplot();
    $counter = 1;
    #  Gnuplot_earth();

    system("convert grid.ps -size 100x200 -rotate 90 grid.jpg");#convert from ps to jpg
    system("chmod a+rw grid.jpg");
    system(" mv grid.jpg /home/simos/public_html/images/ArithmAnal/PDEs/");
    system("convert grid3d.ps -size 100x200 -rotate 90 grid3d.jpg");#convert from ps to jpg
    system("chmod a+rw grid3d.jpg");
    system(" mv grid3d.jpg /home/simos/public_html/images/ArithmAnal/PDEs/");
    system("convert solution.ps -size 100x200 -rotate 90 solution.jpg");#convert from ps to jpg
    system("chmod a+rw solution.jpg");
    system(" mv solution.jpg /home/simos/public_html/images/ArithmAnal/PDEs/");
    return_form();                               #call subroutine return_form
    webtail();
    print $object->end_html();                   #end the html
  }

if($counter eq 0)
  {
    print $object->start_form(),
      $object->body('Time out'),$object->br,
	$object->end_form();
  }

sub print_header
{
    print $object ->header('text/html');                                           #create an http header
    print  $object->start_html('Interactive Elliptic Partial Differential Equation solver',         #start the html
			       'kokkotas@astro.auth.gr'),
    $object->h1('Interactive Elliptic Partial Differential Equation solver'),               #level 1 header
    $object->startform('POST');
}

sub print_form
{
  print $object->start_form('POST'),
    $object->body('This is an Elliptic-PDE-solver. It solves the given PDE with different boundary conditions. The user provides the right hand side of the PDE, the boundaries, the boundary conditions and the approximate number of grid points at one direction. After pressing the "Solve it" button, the program plots the grid of the boundary conditions and the solution of the problem which is a 3D plot of <font color=red> u(x,y) <font color=black>.', $object->b("<font color=blue>", 'All trigonometric functions are supported. Powers must be entered using **, for example x^2 must be entered as x**2. The natural logarithm o x must be entered as log(x). In function f(x), it is suggested to put a space before and after each x.', $object->b(" <font color=black>", ' For questions or to report problems please contact: simos@astro.auth.gr '))),
  $object->p,
  $object->body('*Please give your name: '),
  $object->textfield('name','guest','40','40'),                                #create a text field
  $object->p,
  $object->body('Please give the constant right hand side of the elliptic PDE:'),$object->p,$object->b('<font color=red> u<sub>xx</sub> + u<sub>yy</sub> = <font color=black>'),
  $object->textfield('k','sin(x)*sin(y)','40','40'),
  $object->br,
    $object->body('<font color-black> (If you give "0" then the equation will be the Laplace PDE)'),
      $object->p,
	$object->body('Please give the boundaries:(Please use integers)'),$object->br,
	  $object->body('<font color=blue> x<sub>min</sub> = '),
	    $object->textfield('x_min','0','20','20'),$object->br,
	      $object->body('<font color=blue> x<sub>max</sub> = '),
		$object->textfield('x_max','5','20','20'),$object->br,
		  $object->body('<font color=blue> y<sub>min</sub> = '),
		    $object->textfield('y_min','0','20','20'),$object->br,
		      $object->body('<font color=blue> y<sub>max</sub> = '),
			$object->textfield('y_max','5','20','20'),$object->p,
			  $object->body('<font color=black> Please give the following boundary conditions as functions of x and y for the above equation:'),$object->br,
			    $object->body('<font color=blue> u(x,y<sub>min</sub>) = '),
			      $object->textfield('u_x0','exp(- (x-2.5)**2 )','40','40'),$object->body('(function of x)'),$object->br,
				$object->body('<font color=blue> u(x<sub>min</sub>,y) = '),
				  $object->textfield('u_0y','exp(- (y-2.5)**2 )','40','40'),$object->body('(function of y)'),$object->br,
				    $object->body('<font color=blue> u(x,y<sub>max</sub>) = '),
				      $object->textfield('u_x5','-exp(- (x-2.5)**2 )','40','40'),$object->body('(function of x)'),$object->br,
					$object->body('<font color=blue> u(x<sub>max</sub>,y) = '),
					  $object->textfield('u_5y','-exp(- (y-2.5)**2 )','40','40'),$object->body('(function of y)'),$object->p,
					    $object->body('<font color=black> Please give approximate number of grid points at each direction, <font color=blue> n = <font color=black> '),
					      $object->textfield('points','20','40','40'),$object->p;
  $x_min = $object->param('x_min');
  $x_max = $object->param('x_max');
  $y_min = $object->param('y_min');
  $y_max = $object->param('y_max');
  $k = $object->param('k');
  $u_x0 = $object->param('u_x0');
  $u_0y = $object->param('u_0y');
  $u_x5 = $object->param('u_x5');
  $u_5y = $object->param('u_5y');
  $points = $object->param('points');
  $name = $object->param('name');
  $xx = '$x';
  $yy = '$y';

  $function = $k;
  $k =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($xx)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $k =~ s/\*x/*($xx)/gi;                          #replace *x with *($x)
  $k =~ s/x\*/($xx)*/gi;                          #replace x* with ($x)*
  $k =~ s/\sx/($xx)/gi;                           #replace  x with ($x)
  $k =~ s/x\s/($xx)/gi;                           #replace x  with ($x)
  $k =~ s/\+x / +($xx)/gi;                        #replace +x with +($x)
  $k =~ s/x\+/($xx)+/gi;                          #replace x+ with ($x)+
  $k =~ s/\-x/-($xx)/gi;                          #replace -x with -($x)
  $k =~ s/x\-/($xx)-/gi;                          #replace x- with ($x)

  $k =~ s/[^a-z \+\*\-]y[^a-z \*\+\-]/($yy)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $k =~ s/\*y/*($yy)/gi;                          #replace *x with *($x)
  $k =~ s/y\*/($yy)*/gi;                          #replace x* with ($x)*
  $k =~ s/\sy/($yy)/gi;                           #replace  x with ($x)
  $k =~ s/y\s/($yy)/gi;                           #replace x  with ($x)
  $k =~ s/\+y / +($yy)/gi;                        #replace +x with +($x)
  $k =~ s/y\+/($yy)+/gi;                          #replace x+ with ($x)+
  $k =~ s/\-y/-($yy)/gi;                          #replace -x with -($x)
  $k =~ s/y\-/($yy)-/gi;                          #replace x- with ($x)

  $u_x_0 = $u_x0;
  $u_x0 =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($xx)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $u_x0 =~ s/\*x/*($xx)/gi;                          #replace *x with *($x)
  $u_x0 =~ s/x\*/($xx)*/gi;                          #replace x* with ($x)*
  $u_x0 =~ s/\sx/($xx)/gi;                           #replace  x with ($x)
  $u_x0 =~ s/x\s/($xx)/gi;                           #replace x  with ($x)
  $u_x0 =~ s/\+x / +($xx)/gi;                        #replace +x with +($x)
  $u_x0 =~ s/x\+/($xx)+/gi;                          #replace x+ with ($x)+
  $u_x0 =~ s/\-x/-($xx)/gi;                          #replace -x with -($x)
  $u_x0 =~ s/x\-/($xx)-/gi;                          #replace x- with ($x)

  $u_0_y = $u_0y;
  $u_0y =~ s/[^a-z \+\*\-]y[^a-z \*\+\-]/($yy)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $u_0y =~ s/\*y/*($yy)/gi;                          #replace *x with *($x)
  $u_0y =~ s/y\*/($yy)*/gi;                          #replace x* with ($x)*
  $u_0y =~ s/\sy/($yy)/gi;                           #replace  x with ($x)
  $u_0y =~ s/y\s/($yy)/gi;                           #replace x  with ($x)
  $u_0y =~ s/\+y / +($yy)/gi;                        #replace +x with +($x)
  $u_0y =~ s/y\+/($yy)+/gi;                          #replace x+ with ($x)+
  $u_0y =~ s/\-y/-($yy)/gi;                          #replace -x with -($x)
  $u_0y =~ s/y\-/($yy)-/gi;                          #replace x- with ($x)

  $u_x_5 = $u_x5;
  $u_x5 =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($xx)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $u_x5 =~ s/\*x/*($xx)/gi;                          #replace *x with *($x)
  $u_x5 =~ s/x\*/($xx)*/gi;                          #replace x* with ($x)*
  $u_x5 =~ s/\sx/($xx)/gi;                           #replace  x with ($x)
  $u_x5 =~ s/x\s/($xx)/gi;                           #replace x  with ($x)
  $u_x5 =~ s/\+x / +($xx)/gi;                        #replace +x with +($x)
  $u_x5 =~ s/x\+/($xx)+/gi;                          #replace x+ with ($x)+
  $u_x5 =~ s/\-x/-($xx)/gi;                          #replace -x with -($x)
  $u_x5 =~ s/x\-/($xx)-/gi;                          #replace x- with ($x)

  $u_5_y = $u_5y;
  $u_5y =~ s/[^a-z \+\*\-]y[^a-z \*\+\-]/($yy)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $u_5y =~ s/\*y/*($yy)/gi;                          #replace *x with *($x)
  $u_5y =~ s/y\*/($yy)*/gi;                          #replace x* with ($x)*
  $u_5y =~ s/\sy/($yy)/gi;                           #replace  x with ($x)
  $u_5y =~ s/y\s/($yy)/gi;                           #replace x  with ($x)
  $u_5y =~ s/\+y / +($yy)/gi;                        #replace +x with +($x)
  $u_5y =~ s/y\+/($yy)+/gi;                          #replace x+ with ($x)+
  $u_5y =~ s/\-y/-($yy)/gi;                          #replace -x with -($x)
  $u_5y =~ s/y\-/($yy)-/gi;                          #replace x- with ($x)


  print $object->p;
  print $object->submit(-name=>'GO1', -value=>'Solve it'),                   #submit button
  $object->p;
  print $object->reset('Reset to default values','Reset to default values'),                 #reset button
  $object->p;
  print $object->defaults('Erase everything','Erase everything'),
  $object->p;
  print $object->body('(If no result is obtained in 200 seconds, the server stops the application.'),$object->br,
    $object->body('In this case, please use different boundaries and/or n.) '),$object->p,
      $object->body('After pressing the "Solve it" button, please wait...'), $object->p;
  print $object->body(`date`);                                          #print date and time on page

  print $object->end_form();                                            #end the current form 
  print $object->hr;                                                    #print a horisontal line

}


sub print_to_file
  {
    open(DATA,">dataR.dat") || die("Error");
    close(DATA);
    open(DATA1,">>dataR.dat") || die("Error");
    $dx = abs($x_max-$x_min)/$steps;
    $h = abs($x_max-$x_min)/5;
    $x = $x_min - $dx;
    for ($i=1;$i<=$steps+1;$i++)
    {
	$x = $x + $dx;
	$f = eval $funct;
	print DATA1 "$x $f", "\n";
    }
    close(DATA1);
}

sub grid
  {

    open(DATA,">grid.dat") || die("Error");
    close(DATA);
    open(DATA1,">>grid.dat") || die("Error");
    $x_space = $x_max - $x_min;
    $y_space = $y_max - $y_min;

  if($ypoints>60)
    {
      print $object->b('Too many grid points at the y direction! (n=',$ypoints,'). Please try again with different boundaries and/or n. For simplicity use a square grid.'), $object->end_form(),$object->end_html;
      die;
    }
  if( $x_space-$y_space lt 0)
    {
      $xpoints = $points-1;
      $yy = $y_min;
      while($yy lt $y_max)
	{	
	  $xpoints = $xpoints+1;
	  $ypoints = int($y_space/$x_space*$xpoints);
	  $dx = $x_space/$xpoints;
	  $yy = $y_min + $ypoints*$dx;
	  if($ypoints>60)
	    {
	      print $object->b('Too many grid points at the y direction! (n=',$ypoints,'). Please try again with different boundaries and/or n. For simplicity use a square grid.'), $object->end_form(),$object->end_html;
	      die;
	    }
	}
    }
  
  if( ($x_space-$y_space) gt 0)
    {
      $ypoints = $points-1;
      $xx = $x_min;
      while($xx lt $x_max)
	{	
	  $ypoints = $ypoints+1;
	  $xpoints = int($x_space/$y_space*$ypoints);
	  $dx = $y_space/$ypoints;
	  $xx = $x_min + $xpoints*$dx;
	  if($xpoints>60)
	    {
	      print $object->b('Too many grid points at the x direction!(n=',$xpoints,'). Please try again with different boundaries and/or n. For simplicity use a square grid.'), $object->end_form(),$object->end_html;
	      die;
	    }
	}
    }
    
    if( ($x_space-$y_space) eq 0)
      {
	$dx = $x_space/$points;
	$xpoints = $x_space/$dx;
	$ypoints = $y_space/$dx;
      }

    $x=$x_min;
    $y=$y_min;
    $f = eval $u_x0;
    print DATA1 "$x $y $f", "\n";
    for ($i=1;$i<=$xpoints;$i++)
      {
	$x = $x + $dx;
	$f = eval $u_x0;
	print DATA1 "$x $y $f", "\n";
      }
    for ($i=1;$i<=$ypoints;$i++)
      {
	$y = $y + $dx;
	$f = eval $u_5y;
	print DATA1 "$x $y $f", "\n";
      }
    for ($i=1;$i<=$xpoints;$i++)
      {
	$x = $x - $dx;
	$f = eval $u_x5;
	print DATA1 "$x $y $f", "\n";
      }
    for ($i=1;$i<=$ypoints;$i++)
      {
	$y = $y - $dx;
	$f = eval $u_0y;
	print DATA1 "$x $y $f", "\n";
      }
    close(DATA1);

    open(DATA2,">grid1.dat") || die("Error");
    close(DATA2);
    open(DATA3,">>grid1.dat") || die("Error");
    $x=$x_min;
    $y=$y_min;
    for ($i=1;$i<$xpoints;$i++)
      {
	$x = $x + $dx;
	for($j=1;$j<$ypoints;$j++)
	  {
	    $y = $y + $dx;
	    print DATA3 "$x $y","\n";
	  }
	$y=$y_min;
      }
    close(DATA3);
  }


sub print_to_logfile
  {
    $server =  $ENV{'SERVER_NAME'};
    $agent =  $ENV{'HTTP_USER_AGENT'}; 
    $ip = $ENV{'REMOTE_ADDR'};  
    open(DATA2,">>inputsR.log") || die;
    print DATA2 " ",`date`;
    print DATA2 " User Data: Name: $name, IP: $ip, Browser: $agent ","\n";
    print DATA2 " User Request: Function: $function, x_min: $x_min, x_max: $x_max ","\n";
    print DATA2 "\n";
    close(DATA2);
  }


sub pde_solver
{
  $x_space = $x_max - $x_min;
  $y_space = $y_max - $y_min;
 
#  if( $x_space-$y_space lt 0)
#    {
#      $xpoints = $points-1;
#      $yy = $y_min;
#      while($yy lt $y_max)
#	{	
#	  $xpoints = $xpoints+1;
#	  $ypoints = int($y_space/$x_space*$xpoints);
#	  $dx = $x_space/$xpoints;
#	  $yy = $y_min + $ypoints*$dx;
#	}
#    }
#
#  if( ($x_space-$y_space) gt 0)
#    {
#      $ypoints = $points-1;
#      $xx = $x_min;
#      while($xx lt $x_max)
#	{	
#	  $ypoints = $ypoints+1;
#	  $xpoints = int($x_space/$y_space*$ypoints);
#	  $dx = $y_space/$ypoints;
#	  $xx = $x_min + $xpoints*$dx;
#	}
#    }
#  
#  if( ($x_space-$y_space) eq 0)
#    {
#      $dx = $x_space/$points;
#      $xpoints = $x_space/$dx;
#      $ypoints = $y_space/$dx;
#    }

  $x = $x_min;
  $y = $y_min;
  open(DATAA,">out.dat") || die("Error");
  close(DATAA);
  open(DATAA1,">>out.dat") || die("Error");

  for($i=0;$i<=$xpoints;$i++)
    {
      for($j=0;$j<=$ypoints;$j++)
	{	
	  $u[$i][$j] = 0;
	  if($x eq $x_min)
	    {
	      $u[$i][$j] = eval $u_0y;
	    }
	  if($y eq $y_min)
	    {
	      $u[$i][$j] = eval $u_x0;
	    }
	  if($y eq $y_max)
	    {
	      $u[$i][$j] = eval $u_x5;
	    }
	  if($x eq $x_max)
	    {
	      $u[$i][$j] = eval $u_5y;
	    }
#	  print DATAA1 "$x $y $i $j  $u[$i][$j]","\n";
	  $y = $y+$dx;
	}
      $y = $y_min;
      $x = $x + $dx;
    }
  $test = 1;
  while( abs( $test-$u[$xpoints/2.0][$ypoints/2.0] ) gt 0.0001)
    {

      $y = $y_min;
      $x = $x_min;
      $test = $u[$xpoints/2.0][$ypoints/2.0];

      for($i=1;$i<$xpoints;$i++)
	{
	  for($j=1;$j<$ypoints;$j++)
	    {
	      $kk = eval $k;
	      $u[$i][$j] = $u[$i][$j] + ($u[$i+1][$j] + $u[$i-1][$j] +$u[$i][$j+1] + $u[$i][$j-1] - 4*$u[$i][$j]  ) / 4.0 - $kk*$dx*$dx/4.0;
	      $y = $y + $dx;
	    }
	  $y = $y_min;
	  $x = $x + $dx;
	}

    }
  $x=$x_min;
  $y=$y_min;
  for($j=0;$j<=$ypoints;$j++)
    {
      for($i=0;$i<=$xpoints;$i++)
	{	
	  print DATAA1 "$x $y $i $j  $u[$i][$j]","\n";
	  $x = $x+$dx;
	}
      print DATAA1 "\n";
      $x = $x_min;
      $y = $y+$dx;
    }

 close(DATAA1);

}

sub return_form
  {
    print $object->start_form();
    print $object->body('Your name is:', $object->b("<font color=blue>",$name)),
      $object->p,
	"<font color=black>";
    print $object->body('You have asked to solve the partial differential equation:'), $object->br,
      $object->b('<font color=red> u<sub>xx</sub> + u<sub>yy</sub> =', $function), $object->br,
	$object->body('<font color=black> with boudary conditions:'),$object->br,
	  $object->b('<font color=blue> u(x,0) = ',$u_x_0), $object->br,
	    $object->b('u(0,y) = ',$u_0_y), $object->br,
	      $object->b('u(x,5) = ',$u_x_5), $object->br,
		$object->b('u(5,y) = ',$u_5_y), $object->br,
		  $object->p,
		      "<font color=black>";
    print $object->body('Here is the plot of the boundary conditions:'),
      $object->p;
    print $object->img({src=>"http://www.astro.auth.gr/~simos/images/ArithmAnal/PDEs/grid.jpg"}),
      $object->p;
    print $object->body('(The green x',"'",'es are the given boundary points. The blue stars (<font color=blue>* <font color=black>) are the internal points where the values of <font color=red>'), $object->b('u(x,y) <font color=black>'), $object->body(' has to be calclulated.)');
    print $object->p, $object->body(' Number of grid points at x direction =', $xpoints),$object->br;
    print $object->body(' Number of grid points at y direction =', $ypoints);
    print $object->p;
    print $object->body('Here is the 3d plot of the boundary conditions:'),
      $object->p;
    print $object->img({src=>"http://www.astro.auth.gr/~simos/images/ArithmAnal/PDEs/grid3d.jpg"}),
      $object->p;
    print $object->body('This is the result:'),
      $object->p,
	$object->img({src=>"http://www.astro.auth.gr/~simos/images/ArithmAnal/PDEs/solution.jpg"});
    print $object->p;
#      print $object->body('This is the Earth:'),
#	$object->p,
#	  $object->img({src=>"Earth.gif"});
  }


sub Gnuplot
  {
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
   set tit " This is the plot of u(x,y) "               #the title of the plot
        set grid
        set hidden3d
        set cntrparam levels auto 15
        set auto
        set data style lines
        set parametric
        set contour base
        set o "solution.ps"                                                           #the name of the plot
        set terminal pos color
	set ylabel "y"
        set xlabel "x"
        set zlabel "u(x,y)"
	splot [][][] "out.dat" u 1:2:5 w linespoints
gnuplot_Commands_done
    close(GNUPLOT);
  }

#        set label "u(0,y) = $u_0_y" at -0.8,2.5
#        set label "u(x,0) = $u_x_0" at  2.5,-0.3
#        set label "u(5,y) = $u_5_y" at  5.2,2.5
#        set label "u(x,5) = $u_x_5" at  2.5,5.2

sub Gnuplot_earth
  {
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
         set nokey
         set nozeroaxis
         set angles degrees
         set o "Earth.ps"
         set terminal pos color
         set title "Thessaloniki on the Earth"
         set ticslevel 0
         set view 60,100
         set view ,,1.5
         set mapping spherical
         set parametric
         set samples 32
         set isosamples 20
         set urange [-90:90]
         set vrange [0:360]
         splot cos(u)*cos(v),cos(u)*sin(v),sin(u) with lines 5 6,'world.dat' u 1:2 w l lt 3 lw 2,'world.cor' u 1:2 w p pt 3 ps 3 lt 1
gnuplot_Commands_done
    close(GNUPLOT);
  }


sub Gnuplot_plegma
  {
    $ratio = $y_space/$x_space;
    $xtics = $x_space/$xpoints*5;
    $ytics = $y_space/$ypoints*5;
    $a1 = $x_min-($x_max-$x_min)/15;
    $a2 = $y_min + ($y_max-$y_min)/2;
    $a3 = $x_min + ($x_max-$x_min)/3;
    $a4 = $y_min - ($y_max - $y_min)/15;
    $a5 = $x_max+($x_max-$x_min)/15;
    $a6 = $y_min + ($y_max-$y_min)/2;
    $a7 = $y_max + ($y_max-$y_min)/15;
#$(x_max-$x_min)/2 ,$y_max.2
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit " This is the grid of boundary conditions "               #the title of the plot
	unset key
        set size ratio $ratio
        set xtics $xtics
        set ytics $ytics
        set grid
      	set o "grid.ps"                                              #the name of the plot
	set terminal pos color
	set ylabel "y"
	set xlabel "x"
        set label "u($x_min,y) = $u_0_y" at $a1,$a2 rotate by -90 center
        set label "u(x,$y_min) = $u_x_0" at $a3,$a4
        set label "u($x_max,y) = $u_5_y" at $a5,$a6 rotate by -90 center
        set label "u(x,$y_max) = $u_x_5" at $a3,$a7
	plot [$x_min-($x_max-$x_min)/4.0:$x_max+($x_max-$x_min)/4.0][$y_min-($y_max-$y_min)/5.0:$y_max+($y_max-$y_min)/5.0] "grid.dat" u 1:2 w l, "grid.dat" u 1:2 w p pt 2, "grid1.dat" u 1:2 w p pt 3
gnuplot_Commands_done
    close(GNUPLOT);
  }

sub Gnuplot_3dplegma
  {
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit " This is the 3d grid of boundary conditions "               #the title of the plot
	unset key
        set grid
        set contour base
        set view 60,30
      	set o "grid3d.ps"                                                           #the name of the plot
	set terminal pos color
	set ylabel "y"
	set xlabel "x"
        set zlabel "z"
        set label "u(0,y) = $u_0_y" at $a1,$a2
        set label "u(x,0) = $u_x_0" at $a3,$a4
        set label "u(5,y) = $u_5_y" at $a5,$a6
        set label "u(x,5) = $u_x_5" at $a3,$a7
	splot [$x_min-($x_max-$x_min)/4.0:$x_max+($x_max-$x_min)/4.0][$y_min-($y_max-$y_min)/5.0:$y_max+($y_max-$y_min)/5.0] "grid.dat" u 1:2:3 w l, "grid.dat" u 1:2:3 w p pt 2
gnuplot_Commands_done
    close(GNUPLOT);
  }








#counts the visits and prints to the webpage
sub webtail
{
    print $object->p,
    $object->hr;
    $countfile = "cgicountR";
    $count = `cat $countfile`;
    chop($count);
    $count = $count + 1;
    open(INF,">$countfile");
    print INF "$count\n";
    close(INF);
    print $object->a({href=>"http://www.astro.auth.gr/~simos/cgi-bin/link.pl"}, 'Back to the Interactive Numerical Analysis page'); 
    print $object->hr;  
    print $object->p;
    #print the counter and contact e-mail address
    print $object->body("<font color = black>", "<font size=1.5>",'This web page has been visited: ',"<font color=red>",$count,"<font color=black>",'times');
    print $object->br;
    print $object->body("<font color=black>","<font size=1.5>",'If you have any comments or questions please contact: ');
    print $object->a({href=>'mailto:simos@astro.auth.gr'},'simos@astro.auth.gr');
    print $object->p;
    print $object->body("<!-- Start of StatCounter Code --><script type='text/javascript' language='javascript'>var sc_project=895250;var sc_invisible=0;var sc_partition=7;var sc_security='ccb97b32';</script><script type='text/javascript' language='javascript' src='http://www.statcounter.com/counter/counter.js'></script><noscript><a href='http://www.statcounter.com/' target='_blank'><img  src='http://c8.statcounter.com/counter.php?sc_project=895250&amp;java=0&amp;security=ccb97b32&amp;invisible=0' alt='web stats' border='0'></a> </noscript>
<!-- End of StatCounter Code -->");
}
