#!/usr/bin/perl
use Math::Trig;
use CGI qw(:standard);                      #call CGI.pm

alarm(360);
$pi = acos(-1);                             #pi
$date = date;
$timeout = 30;
$gnuplot = "gnuplot";
$object = new CGI;                          #create a new CGI object
print_header();                             #call subroutine "print_header"
print_form();                               #call subroutine "form"
if (param())
{
  grid();
  if ($boundary eq 'fixed')
    {
      pde_solver();
    }
  else
    {
      pde_solver1();
    }
  Gnuplot_plegma();
  Gnuplot();
  system("convert grid.ps -size 100x200 -rotate 90 grid.jpg");#convert from ps to jpg
  system("chmod a+rw grid.jpg");
  system(" mv grid.jpg /home/simos/public_html/images/ArithmAnal/PDEs/Wave/");

  system("./whirlgif -minimize -o ani -loop 5 -i list ");

  system("chmod a+rw ani");
  system(" mv ani /home/simos/public_html/images/ArithmAnal/PDEs/Wave/");

  system("rm -f *dat *.gif *.ps");

  return_form();                               #call subroutine return_form
  #  webtail();
  print $object->end_html();                   #end the html
}

sub print_header
{
    print $object ->header('text/html');                                           #create an http header
    print  $object->start_html('Interactive Wave Equation solver',         #start the html
			       'kokkotas@astro.auth.gr'),
    $object->h1('Interactive 1D Wave Equation solver'),               #level 1 header
    $object->startform('POST');
}

sub print_form
  {
    print $object->start_form('POST'),
      $object->body('This is the interactive solver of the 1D Wave Equation. It solves the given PDE with different boundary conditions. The user provides the right hand side of the PDE, the boundaries, the boundary conditions and the approximate number of grid points at one direction. After pressing the "Solve it" button, the program plots the initial conditions and the solution of the problem which is a video of <font color=red> u(x,t) <font color=black>.', $object->b("<font color=blue>", 'All trigonometric functions are supported. Powers must be entered using **, for example x^2 must be entered as x**2. The natural logarithm o x must be entered as log(x). In function f(x), it is suggested to put a space before and after each x.', $object->b(" <font color=black>", ' For questions or to report problems please contact: simos@astro.auth.gr'))),
	$object->p,
	  $object->body('*Please give your name: '),
	    $object->textfield('name','guest','40','40'),                                #create a text field
	      $object->p,
		$object->body('Please give the 1-D Wave Equation'),$object->p,$object->b('<font color=red> u<sub>tt</sub> = '), $object->textfield('c','1','5','5'),$object->b(' u<sub>xx</sub> <font color=black>'),
		  $object->br,
		    $object->body('<font color-black> (The missing is the square of the speed of the wave)'),
		      $object->p,
			$object->body('Please give the boundaries:'),$object->br,
			  $object->body('<font color=blue> x<sub>min</sub> = '),
			    $object->textfield('x_min','0','20','20'),$object->br,
			      $object->body('<font color=blue> x<sub>max</sub> = '),
				$object->textfield('x_max','1','20','20'),$object->p,
				  $object->b('<font color=black> Boundary conditions'),$object->br,
				    #				  $object->body('<font color=blue> y<sub>min</sub> = '),
				    #				    $object->textfield('y_min','0','20','20'),$object->br,
				    #				      $object->body('<font color=blue> y<sub>max</sub> = '),
				    #					$object->textfield('y_max','5','20','20'),$object->p,
				    $object->body('<font color=black> Please choose one of the following boundary conditions: '),$object->br,
					$object->popup_menu(-name=>'boundary',-values=>['fixed','periodic']),$object->p,
					  $object->b('Initial conditions'),$object->br,
					    $object->body(' Please give the initial conditions as functions of x:'),$object->br,
					      $object->body(' <font color=blue> u(x,0) = '),
						$object->textfield('u_x0','sin(2*$pi*x)','40','40'),$object->br,
						  $object->body(' <font color=blue> u<sub>t</sub>(x,0) = <font color=black>'),
						    $object->textfield('ut_x','0','40','40'),$object->br;

    $x_min = $object->param('x_min');
    $x_max = $object->param('x_max');
    $c = $object->param('c');
    $u_0t = $object->param('u_0t');
    $u_5t = $object->param('u_5t');
    $u_x0 = $object->param('u_x0');
    $ut_x = $object->param('ut_x');
    $name = $object->param('name');
    $xx = '$x';
    $yy = '$y';
    $boundary = $object->param('boundary');

    $function = $funct;
    $funct =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($xx)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
    $funct =~ s/\*x/*($xx)/gi;                          #replace *x with *($x)
    $funct =~ s/x\*/($xx)*/gi;                          #replace x* with ($x)*
    $funct =~ s/\sx/($xx)/gi;                           #replace  x with ($x)
    $funct =~ s/x\s/($xx)/gi;                           #replace x  with ($x)
    $funct =~ s/\+x / +($xx)/gi;                        #replace +x with +($x)
    $funct =~ s/x\+/($xx)+/gi;                          #replace x+ with ($x)+
    $funct =~ s/\-x/-($xx)/gi;                          #replace -x with -($x)
    $funct =~ s/x\-/($xx)-/gi;                          #replace x- with ($x)
    
    $funct =~ s/[^a-z \+\*\-]y[^a-z \*\+\-]/($yy)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
    $funct =~ s/\*y/*($yy)/gi;                          #replace *x with *($x)
    $funct =~ s/y\*/($yy)*/gi;                          #replace x* with ($x)*
    $funct =~ s/\sy/($yy)/gi;                           #replace  x with ($x)
    $funct =~ s/y\s/($yy)/gi;                           #replace x  with ($x)
    $funct =~ s/\+y / +($yy)/gi;                        #replace +x with +($x)
    $funct =~ s/y\+/($yy)+/gi;                          #replace x+ with ($x)+
    $funct =~ s/\-y/-($yy)/gi;                          #replace -x with -($x)
    $funct =~ s/y\-/($yy)-/gi;                          #replace x- with ($x)

    $u_x_0 = $u_x0;
    $u_x0 =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($xx)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
    $u_x0 =~ s/\*x/*($xx)/gi;                          #replace *x with *($x)
    $u_x0 =~ s/x\*/($xx)*/gi;                          #replace x* with ($x)*
    $u_x0 =~ s/\sx/($xx)/gi;                           #replace  x with ($x)
    $u_x0 =~ s/x\s/($xx)/gi;                           #replace x  with ($x)
    $u_x0 =~ s/\+x / +($xx)/gi;                        #replace +x with +($x)
    $u_x0 =~ s/x\+/($xx)+/gi;                          #replace x+ with ($x)+
    $u_x0 =~ s/\-x/-($xx)/gi;                          #replace -x with -($x)
    $u_x0 =~ s/x\-/($xx)-/gi;                          #replace x- with ($x)

    $ut_x = $ut_x;
    $ut_x =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($xx)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
    $ut_x =~ s/\*x/*($xx)/gi;                          #replace *x with *($x)
    $ut_x =~ s/x\*/($xx)*/gi;                          #replace x* with ($x)*
    $ut_x =~ s/\sx/($xx)/gi;                           #replace  x with ($x)
    $ut_x =~ s/x\s/($xx)/gi;                           #replace x  with ($x)
    $ut_x =~ s/\+x / +($xx)/gi;                        #replace +x with +($x)
    $ut_x =~ s/x\+/($xx)+/gi;                          #replace x+ with ($x)+
    $ut_x =~ s/\-x/-($xx)/gi;                          #replace -x with -($x)
    $ut_x =~ s/x\-/($xx)-/gi;                          #replace x- with ($x)


    print $object->p;
    print $object->submit(-name=>'GO1', -value=>'Solve it'),                   #submit button
      $object->p;
    print $object->reset('Reset to default values','Reset to default values'),                 #reset button
      $object->p;
    print $object->defaults('Erase everything','Erase everything'),
      $object->p;
    print $object->body(`date`);                                          #print date and time on page
    print $object->end_form();                                            #end the current form 
    print $object->hr;                                                    #print a horisontal line

}


sub print_to_file
  {
    open(DATA,">dataR.dat") || die("Error");
    close(DATA);
    open(DATA1,">>dataR.dat") || die("Error");
    $dx = abs($x_max-$x_min)/$steps;
    $h = abs($x_max-$x_min)/5;
    $x = $x_min - $dx;
    for ($i=1;$i<=$steps+1;$i++)
    {
	$x = $x + $dx;
	$f = eval $funct;
	print DATA1 "$x $f", "\n";
    }
    close(DATA1);
}

sub grid
  {

    open(DATA,">grid.dat") || die("Error");
    close(DATA);
    open(DATA1,">>grid.dat") || die("Error");
    $x_space = $x_max - $x_min;

    $dx = 0.01;
    $dt = $dx * sqrt($c);
    $xpoints = $x_space/$dx;

    $x=$x_min;
    $f = eval $u_x0;
    $u[0][0] = $f;
    $u[1][0] = $f;
    $g = eval $ut_x;
    $ut[1][0] = $g;

    print DATA1 "$x $f", "\n";
    for ($i=2;$i<=$xpoints+1;$i++)
      {
	$x = $x + $dx;
	$f = eval $u_x0;
	$u[$i][0] = $f;

	$g = eval $ut_x;
	$ut[$i][0] = $g;
	print DATA1 "$x $f", "\n";
      }
    close(DATA1);
    $u[$xpoints+2][0] = $u[$xpoints+1][0];
  }


sub pde_solver
{
  $x_space = $x_max - $x_min;

  $time_steps = int(3.0*$x_space/sqrt($c)/$dt);

  $x = $x_min;

  $t = 0;
  open(DATAA,">0.dat") || die("Error");
  close(DATAA);
  open(DATAA1,">>0.dat") || die("Error");

  for($i=1;$i<=$xpoints+1;$i++)
    {
      print DATAA1 "$x $t $u[$i][0]","\n";
      $x = $x+$dx;
    }
  print DATAA1 "\n";
  close(DATAA1);

  open(DATAA,">1.dat") || die("Error");
  close(DATAA);
  open(DATAA1,">>1.dat") || die("Error");
  $x = $x_min;
  $t = $t+$dt;
  $u[1][1] = $u[1][0];
  print DATAA1 "$x $t $u[1][1]","\n";
  for($i=2;$i<=$xpoints;$i++)
    {
      $u[$i][1] = $u[$i][0] + $dt*$ut[$i][0];
      print DATAA1 "$x $t $u[$i][1]","\n";
      $x = $x+$dx;
    }
  $u[$xpoints+1][1] = $u[$xpoints+1][0];
  print DATAA1 "$x $t $u[$xpoints][1]","\n";
  print DATAA1 "\n";
  close(DATAA1);


  $x = $x_min;
  for($j=1;$j<$time_steps;$j++)
    {
      $jj = $j+1;
      open(DATAA,">$jj.dat") || die("Error");
      close(DATAA);
      open(DATAA1,">>$jj.dat") || die("Error");
      $t = $t + $dt;
      print DATAA1 "$x_min $t $u[1][0]","\n";
      $u[1][$j] = $u[1][0];
      for($i=2;$i<$xpoints+1;$i++)
	{
	  $x = $x + $dx;
	  $u[$i][$j+1] = $u[$i+1][$j] + $u[$i-1][$j] - $u[$i][$j-1];
	  print DATAA1 "$x $t $u[$i][$j+1]","\n";
	}
      $u[$xpoints+1][$j] = $u[$xpoints+1][0];
      print DATAA1 "$x_max $t $u[$xpoints+1][0]","\n";
      print DATAA1 "\n";
      $x = $x_min;
      close(DATAA1);
    }
}

sub pde_solver1
{
  $x_space = $x_max - $x_min;

  $time_steps = int(3.0*$x_space/sqrt($c)/$dt);

  $x = $x_min;

  $t = 0;
  open(DATAA,">0.dat") || die("Error");
  close(DATAA);
  open(DATAA1,">>0.dat") || die("Error");

  for($i=1;$i<=$xpoints+1;$i++)
    {
      print DATAA1 "$x $t $u[$i][0]","\n";
      $x = $x+$dx;
    }
  $u[0][0] = $u[1][0];
  $u[$xpoints+2][0] = $u[$xpoints+1][0];
  print DATAA1 "\n";
  close(DATAA1);

  open(DATAA,">1.dat") || die("Error");
  close(DATAA);
  open(DATAA1,">>1.dat") || die("Error");
  $x = $x_min;
  $t = $t+$dt;
  $u[0][1] = $u[0][0];
#  print DATAA1 "$x $t $u[0][1]","\n";
  for($i=1;$i<=$xpoints+1;$i++)
    {
      $u[$i][1] = $u[$i][0] + $dt*$ut[$i][0];
      print DATAA1 "$x $t $u[$i][1]","\n";
      $x = $x+$dx;
    }
  $u[$xpoints+2][1] = $u[$0][1];
  print DATAA1 "$x $t $u[$xpoints][1]","\n";
  print DATAA1 "\n";
  close(DATAA1);


  $x = $x_min;
  for($j=1;$j<$time_steps;$j++)
    {
      $jj = $j+1;
      open(DATAA,">$jj.dat") || die("Error");
      close(DATAA);
      open(DATAA1,">>$jj.dat") || die("Error");
      $t = $t + $dt;
#      print DATAA1 "$x_min $t $u[0][0]","\n";
      $u[0][$j] = $u[0][$j-1];
      for($i=1;$i<$xpoints+1;$i++)
	{
	  $x = $x + $dx;
	  $u[$i][$j+1] = $u[$i+1][$j] + $u[$i-1][$j] - $u[$i][$j-1];
	  print DATAA1 "$x $t $u[$i][$j+1]","\n";
	}
      $u[$xpoints+1][$j] = $u[1][$j];
      print DATAA1 "$x_max $t $u[$xpoints+1][$j]","\n";
      print DATAA1 "\n";
      $x = $x_min;
      close(DATAA1);
    }
}


sub return_form
  {
    print $object->start_form();
    print $object->body('Your name is:', $object->b("<font color=blue>",$name)),
      $object->p,
	"<font color=black>";
    print $object->body('You have asked to solve the wave equation:'), $object->br,
      $object->b('<font color=red> u<sub>tt</sub> = ',$c,' u<sub>xx</sub> '), $object->p,
	$object->body('<font color=black> with boudary conditions:'),$object->br,
	  $object->b('<font color=blue> u(0,t) = ',$u_0_t), $object->br,
	    $object->b('u(',$x_max,',t) = ',$u_5_t), $object->p,
	      $object->body(' <font color=black> with initial conditions: <font color=blue>'),$object->br,
		$object->b('u(x,0) = ',$u_x_0), $object->br,
		  $object->b('u<sub>t</sub>(x,0) = ',$ut_x), $object->br,
		    $object->p,
		      "<font color=black>";
    print $object->body('Here is the plot of the initial conditions:'),
      $object->p;
    print $object->img({src=>"http://www.astro.auth.gr/~simos/images/ArithmAnal/PDEs/Wave/grid.jpg"}),
      $object->p;
    print $object->p, $object->body(' Number of grid points at x direction =', $xpoints);
    print $object->p;
    #    print $object->body('Here is the 3d plot of the boundary conditions:'),
#      $object->p;
    #    print $object->img({src=>"grid3d.gif"}),
    #      $object->p;
#    print $object->body('This is the result:'),
#      $object->p,
#    	$object->img({src=>"0.gif"});
#    print $object->body('This is the result:'),
#      $object->p,
#    	$object->img({src=>"50.gif"});
    print $object->body('This is the result: (It is an animated video. You can save it and then open it with an image viewer, if it runs too slow.)'),
      $object->p,
    	$object->img({src=>"http://www.astro.auth.gr/~simos/images/ArithmAnal/PDEs/Wave/ani"});
    print $object->p,
      $object->body('Time step = ', $dt,', number of time steps = ',$time_steps , ', step in space = ', $dx);
    #    print $object->p;
    #      print $object->body('This is the Earth:'),
    #	$object->p,
    #	  $object->img({src=>"Earth.gif"});
  }


sub Gnuplot
  {
    open(DATA,">list") || die("Error");
    close(DATA);
    open(DATA1,">>list") || die("Error");
    $t = 0;
    for($i=0;$i<=$time_steps;$i++)
      {
	$x_pos = $x_max-($x_max-$x_min)/4.0;
	$t = $t + $dt;
	open (GNUPLOT, "|$gnuplot");
	print GNUPLOT <<gnuplot_Commands_done;
          set tit " This is the video of u(x) in time "               #the title of the plot
          set grid
          set o "$i.ps"                                                           #the name of the plot
          set terminal pos color
          set label "time = $t"  at $x_pos,0.8
          set nokey
          set xlabel "x"
          set ylabel "u"
	  plot [$x_min:$x_max][-1:1] "$i.dat" u 1:3 w linespoints
gnuplot_Commands_done
	close(GNUPLOT);
	$j = $i/4;
	$jj = int($i/4);
	if($j eq $jj)
	  {
	    system("convert $i.ps -size 100x200 -rotate 90 $i.gif");#convert from ps to gif
	    print DATA1 "$i.gif","\n";
	  }
      }
    close(DATA1);
  }
#        set label "u(0,y) = $u_0_y" at -0.8,2.5
#        set label "u(x,0) = $u_x_0" at  2.5,-0.3
#        set label "u(5,y) = $u_5_y" at  5.2,2.5
#        set label "u(x,5) = $u_x_5" at  2.5,5.2

sub Gnuplot_earth
  {
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
         set nokey
         set nozeroaxis
         set angles degrees
         set o "Earth.gif"
         set terminal gif
         set title "Thessaloniki on the Earth"
         set ticslevel 0
         set view 60,100
         set view ,,1.5
         set mapping spherical
         set parametric
         set samples 32
         set isosamples 20
         set urange [-90:90]
         set vrange [0:360]
         splot cos(u)*cos(v),cos(u)*sin(v),sin(u) with lines 5 6,'world.dat' u 1:2 w l lt 3 lw 2,'world.cor' u 1:2 w p pt 3 ps 3 lt 1
gnuplot_Commands_done
    close(GNUPLOT);
  }


sub Gnuplot_plegma
  {
#    $ratio = $y_space/$x_space;
#    $xtics = $x_space/$xpoints*5;
#    $ytics = $y_space/$ypoints*5;
#    $a1 = $x_min-($x_max-$x_min)/15;
#    $a2 = $y_min + ($y_max-$y_min)/2;
#    $a3 = $x_min + ($x_max-$x_min)/3;
#    $a4 = $y_min - ($y_max - $y_min)/15;
#    $a5 = $x_max+($x_max-$x_min)/15;
#    $a6 = $y_min + ($y_max-$y_min)/2;
#    $a7 = $y_max + ($y_max-$y_min)/15;
#$(x_max-$x_min)/2 ,$y_max.2
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit " Initial Conditions "               #the title of the plot
	unset key
        set grid
      	set o "grid.ps"                                              #the name of the plot
	set terminal pos color
	set ylabel "u"
	set xlabel "x"
	plot [][] "grid.dat" u 1:2 w l, "grid.dat" u 1:2 w p pt 2
gnuplot_Commands_done
    close(GNUPLOT);
  }

sub Gnuplot_3dplegma
  {
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit " This is the 3d grid of boundary conditions "               #the title of the plot
	unset key
        set grid
        set contour base
        set view 60,30
      	set o "grid3d.ps"                                                           #the name of the plot
	set terminal pos color
	set ylabel "y"
	set xlabel "x"
        set zlabel "z"
        set label "u(0,y) = $u_0_y" at $a1,$a2
        set label "u(x,0) = $u_x_0" at $a3,$a4
        set label "u(5,y) = $u_5_y" at $a5,$a6
        set label "u(x,5) = $u_x_5" at $a3,$a7
	splot [$x_min-($x_max-$x_min)/4.0:$x_max+($x_max-$x_min)/4.0][$y_min-($y_max-$y_min)/5.0:$y_max+($y_max-$y_min)/5.0] "grid.dat" u 1:2:3 w l, "grid.dat" u 1:2:3 w p pt 2
gnuplot_Commands_done
    close(GNUPLOT);
  }








#counts the visits and prints to the webpage
sub webtail
{
    print $object->p,
    $object->hr;
    $countfile = "cgicountR";
    $count = `cat $countfile`;
    chop($count);
    $count = $count + 1;
    open(INF,">$countfile");
    print INF "$count\n";
    close(INF);
    print $object->a({href=>"http://www.astro.auth.gr/~simos/cgi-bin/link.pl"}, 'Back to the Interactive Numerical Analysis page'); 
    print $object->hr;  
    print $object->p;
    #print the counter and contact e-mail address
    print $object->body("<font color = black>", "<font size=1.5>",'This web page has been visited: ',"<font color=red>",$count,"<font color=black>",'times');
    print $object->br;
    print $object->body("<font color=black>","<font size=1.5>",'If you have any comments or questions please contact: ');
    print $object->a({href=>'mailto:simos@astro.auth.gr'},'simos@astro.auth.gr');
    print $object->p;
    print $object->body("<!-- Start of StatCounter Code --><script type='text/javascript' language='javascript'>var sc_project=895250;var sc_invisible=0;var sc_partition=7;var sc_security='ccb97b32';</script><script type='text/javascript' language='javascript' src='http://www.statcounter.com/counter/counter.js'></script><noscript><a href='http://www.statcounter.com/' target='_blank'><img  src='http://c8.statcounter.com/counter.php?sc_project=895250&amp;java=0&amp;security=ccb97b32&amp;invisible=0' alt='web stats' border='0'></a> </noscript>
<!-- End of StatCounter Code -->");
}
