#!/usr/bin/perl
use Math::Trig;
use CGI qw(:standard);                      #call CGI.pm

$pi = acos(-1);                             #pi
$date = date;
$gnuplot = "gnuplot";
$object = new CGI;                          #create a new CGI object
print_header();                             #call subroutine "print_header"
print_form();                               #call subroutine "form"
if (param())
{
#    print_to_logfile();
#    print_to_file();                             #print data to log file "inputsR.log" to have an input reference

  pde_solver();
  grid();
  Gnuplot_plegma();
  Gnuplot_3dplegma();
  Gnuplot();
  Gnuplot_earth();
  return_form();                               #call subroutine return_form
  webtail();
  print $object->end_html();                   #end the html
}

sub print_header
{
    print $object ->header('text/html');                                           #create an http header
    print  $object->start_html('Elliptic Partial Differential Equations',         #start the html
			       'kokkotas@astro.auth.gr'),
    $object->h1('Elliptic Partial Differential Equations'),               #level 1 header
    $object->startform('POST');
}

sub print_form
{
  print $object->start_form('POST'),
    $object->body('( This is an Elliptic-PDE-solver. It solves the Laplace equation with different boundary conditions. The user provides bla bla bla. After pressing the "Solve it" button, the program plots the solution.', $object->b("<font color=blue>", 'All trigonometric functions are supported. Powers must be entered using **, for example x^2 must be entered as x**2. The natural logarithm o x must be entered as log(x). In function f(x), it is suggested to put a space before and after each x.', $object->b(" <font color=black>", ' For questions or to report problems please contact: simos@astro.auth.gr )'))),
  $object->p,
  $object->body('*Please give your name: '),
  $object->textfield('name','guest','20','20'),                                #create a text field
  $object->p,
  $object->body('Please give the constant right hand side of the elliptic PDE:'),$object->p,$object->b('<font color=red> u<sub>xx</sub> + u<sub>yy</sub> = <font color=black>'),
  $object->textfield('k','0','20','20'),
  $object->br,
  $object->body('<font color-black> (If you give "0" then the equation will be the Laplace PDE)'),
  $object->p,
  $object->body('Please give the following boundary conditions for the above equation:'),$object->br,
    $object->body('<font color=blue> u(x,0) = '),
      $object->textfield('u_x0','0','20','20'),$object->br,
	$object->body('<font color=blue> u(0,y) = '),
	  $object->textfield('u_0y','0','20','20'),$object->br,
	    $object->body('<font color=blue> u(x,5) = '),
	      $object->textfield('u_x5','0','20','20'),$object->br,
		$object->body('<font color=blue> u(5,y) = <font color=black>'),
		  $object->textfield('u_5y','0','20','20'),$object->p,
		    $object->body('Please give number of grid points at each direction, n = '),
		      $object->textfield('points','10','20','20'),$object->p;

  $k = $object->param('k');
  $u_x0 = $object->param('u_x0');
  $u_0y = $object->param('u_0y');
  $u_x5 = $object->param('u_x5');
  $u_5y = $object->param('u_5y');
  $points = $object->param('points');
  $name = $object->param('name');
  $xx = '$x';
  $yy = '$y';

  $function = $funct;
  $funct =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($xx)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $funct =~ s/\*x/*($xx)/gi;                          #replace *x with *($x)
  $funct =~ s/x\*/($xx)*/gi;                          #replace x* with ($x)*
  $funct =~ s/\sx/($xx)/gi;                           #replace  x with ($x)
  $funct =~ s/x\s/($xx)/gi;                           #replace x  with ($x)
  $funct =~ s/\+x / +($xx)/gi;                        #replace +x with +($x)
  $funct =~ s/x\+/($xx)+/gi;                          #replace x+ with ($x)+
  $funct =~ s/\-x/-($xx)/gi;                          #replace -x with -($x)
  $funct =~ s/x\-/($xx)-/gi;                          #replace x- with ($x)

  $funct =~ s/[^a-z \+\*\-]y[^a-z \*\+\-]/($yy)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $funct =~ s/\*y/*($yy)/gi;                          #replace *x with *($x)
  $funct =~ s/y\*/($yy)*/gi;                          #replace x* with ($x)*
  $funct =~ s/\sy/($yy)/gi;                           #replace  x with ($x)
  $funct =~ s/y\s/($yy)/gi;                           #replace x  with ($x)
  $funct =~ s/\+y / +($yy)/gi;                        #replace +x with +($x)
  $funct =~ s/y\+/($yy)+/gi;                          #replace x+ with ($x)+
  $funct =~ s/\-y/-($yy)/gi;                          #replace -x with -($x)
  $funct =~ s/y\-/($yy)-/gi;                          #replace x- with ($x)

  $u_x_0 = $u_x0;
  $u_x0 =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($xx)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $u_x0 =~ s/\*x/*($xx)/gi;                          #replace *x with *($x)
  $u_x0 =~ s/x\*/($xx)*/gi;                          #replace x* with ($x)*
  $u_x0 =~ s/\sx/($xx)/gi;                           #replace  x with ($x)
  $u_x0 =~ s/x\s/($xx)/gi;                           #replace x  with ($x)
  $u_x0 =~ s/\+x / +($xx)/gi;                        #replace +x with +($x)
  $u_x0 =~ s/x\+/($xx)+/gi;                          #replace x+ with ($x)+
  $u_x0 =~ s/\-x/-($xx)/gi;                          #replace -x with -($x)
  $u_x0 =~ s/x\-/($xx)-/gi;                          #replace x- with ($x)

  $u_0_y = $u_0y;
  $u_0y =~ s/[^a-z \+\*\-]y[^a-z \*\+\-]/($yy)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $u_0y =~ s/\*y/*($yy)/gi;                          #replace *x with *($x)
  $u_0y =~ s/y\*/($yy)*/gi;                          #replace x* with ($x)*
  $u_0y =~ s/\sy/($yy)/gi;                           #replace  x with ($x)
  $u_0y =~ s/y\s/($yy)/gi;                           #replace x  with ($x)
  $u_0y =~ s/\+y / +($yy)/gi;                        #replace +x with +($x)
  $u_0y =~ s/y\+/($yy)+/gi;                          #replace x+ with ($x)+
  $u_0y =~ s/\-y/-($yy)/gi;                          #replace -x with -($x)
  $u_0y =~ s/y\-/($yy)-/gi;                          #replace x- with ($x)

  $u_x_5 = $u_x5;
  $u_x5 =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($xx)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $u_x5 =~ s/\*x/*($xx)/gi;                          #replace *x with *($x)
  $u_x5 =~ s/x\*/($xx)*/gi;                          #replace x* with ($x)*
  $u_x5 =~ s/\sx/($xx)/gi;                           #replace  x with ($x)
  $u_x5 =~ s/x\s/($xx)/gi;                           #replace x  with ($x)
  $u_x5 =~ s/\+x / +($xx)/gi;                        #replace +x with +($x)
  $u_x5 =~ s/x\+/($xx)+/gi;                          #replace x+ with ($x)+
  $u_x5 =~ s/\-x/-($xx)/gi;                          #replace -x with -($x)
  $u_x5 =~ s/x\-/($xx)-/gi;                          #replace x- with ($x)

  $u_5_y = $u_5y;
  $u_5y =~ s/[^a-z \+\*\-]y[^a-z \*\+\-]/($yy)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $u_5y =~ s/\*y/*($yy)/gi;                          #replace *x with *($x)
  $u_5y =~ s/y\*/($yy)*/gi;                          #replace x* with ($x)*
  $u_5y =~ s/\sy/($yy)/gi;                           #replace  x with ($x)
  $u_5y =~ s/y\s/($yy)/gi;                           #replace x  with ($x)
  $u_5y =~ s/\+y / +($yy)/gi;                        #replace +x with +($x)
  $u_5y =~ s/y\+/($yy)+/gi;                          #replace x+ with ($x)+
  $u_5y =~ s/\-y/-($yy)/gi;                          #replace -x with -($x)
  $u_5y =~ s/y\-/($yy)-/gi;                          #replace x- with ($x)


  print $object->p;
  print $object->submit(-name=>'GO1', -value=>'Calculate it'),                   #submit button
  $object->p;
  print $object->reset('Reset to default values','Reset to default values'),                 #reset button
  $object->p;
  print $object->defaults('Erase everything','Erase everything'),
  $object->p;
  print $object->body(`date`);                                          #print date and time on page
  print $object->end_form();                                            #end the current form 
  print $object->hr;                                                    #print a horisontal line

}


sub print_to_file
  {
    open(DATA,">dataR.dat") || die("Error");
    close(DATA);
    open(DATA1,">>dataR.dat") || die("Error");
    $dx = abs($x_max-$x_min)/$steps;
    $h = abs($x_max-$x_min)/5;
    $x = $x_min - $dx;
    for ($i=1;$i<=$steps+1;$i++)
    {
	$x = $x + $dx;
	$f = eval $funct;
	print DATA1 "$x $f", "\n";
    }
    close(DATA1);
}

sub grid
  {
    open(DATA,">grid.dat") || die("Error");
    close(DATA);
    open(DATA1,">>grid.dat") || die("Error");
    $dx = 5.0/$points;
    $x=0;
    $y=0;
    $f = eval $u_x0;
    print DATA1 "$x $y $f", "\n";
    for ($i=1;$i<=$points;$i++)
      {
	$x = $x + $dx;
	$f = eval $u_x0;
	print DATA1 "$x $y $f", "\n";
      }
    for ($i=1;$i<=$points;$i++)
      {
	$y = $y + $dx;
	$f = eval $u_5y;
	print DATA1 "$x $y $f", "\n";
      }
    for ($i=1;$i<=$points;$i++)
      {
	$x = $x - $dx;
	$f = eval $u_x5;
	print DATA1 "$x $y $f", "\n";
      }
    for ($i=1;$i<=$points;$i++)
      {
	$y = $y - $dx;
	$f = eval $u_0y;
	print DATA1 "$x $y $f", "\n";
      }
    close(DATA1);

    open(DATA2,">grid1.dat") || die("Error");
    close(DATA2);
    open(DATA3,">>grid1.dat") || die("Error");
    $x=0;
    $y=0;
    for ($i=1;$i<$points;$i++)
      {
	$x = $x + $dx;
	for($j=1;$j<$points;$j++)
	  {
	    $y = $y + $dx;
	    print DATA3 "$x $y","\n";
	  }
	$y=0;
      }
    close(DATA3);
  }


sub print_to_logfile
  {
    $server =  $ENV{'SERVER_NAME'};
    $agent =  $ENV{'HTTP_USER_AGENT'}; 
    $ip = $ENV{'REMOTE_ADDR'};  
    open(DATA2,">>inputsR.log") || die;
    print DATA2 " ",`date`;
    print DATA2 " User Data: Name: $name, IP: $ip, Browser: $agent ","\n";
    print DATA2 " User Request: Function: $function, x_min: $x_min, x_max: $x_max ","\n";
    print DATA2 "\n";
    close(DATA2);
  }


sub pde_solver
{

  $dx = 5.0/$points;
  $x = 0;
  $y = 0;
  open(DATAA,">out.dat") || die("Error");
  close(DATAA);
  open(DATAA1,">>out.dat") || die("Error");

  for($i=0;$i<=$points;$i++)
    {
      for($j=0;$j<=$points;$j++)
	{	
	  $u[$i][$j] = 0;
	  if($x eq 0)
	    {
	      $u[$i][$j] = eval $u_0y;
	    }
	  if($y eq 0)
	    {
	      $u[$i][$j] = eval $u_x0;
	    }
	  if($y eq 5)
	    {
	      $u[$i][$j] = eval $u_x5;
	    }
	  if($x eq 5)
	    {
	      $u[$i][$j] = eval $u_5y;
	    }
#	  print DATAA1 "$x $y $i $j  $u[$i][$j]","\n";
	  $y = $y+$dx;
	}
      $y = 0;
      $x = $x + $dx;
    }
  $test = 1;
  while( abs( $test-$u[5][5] ) gt 0.0001)
    {
      $test = $u[5][5];
      for($i=1;$i<$points;$i++)
	{
	  for($j=1;$j<$points;$j++)
	    {
	      $u[$i][$j] = $u[$i][$j] + ($u[$i+1][$j] + $u[$i-1][$j] +$u[$i][$j+1] + $u[$i][$j-1] - 4*$u[$i][$j]  ) / 4.0;
#	      print DATAA1 "$u[$i][$j] ";
	    }
#	  print DATAA1 "\n";
	}
#      print DATAA1 "\n";
    }
  $x=0;
  $y=0;
  for($j=0;$j<=$points;$j++)
    {
      for($i=0;$i<=$points;$i++)
	{	
	  print DATAA1 "$x $y $i $j  $u[$i][$j]","\n";
	  $x = $x+$dx;
	}
      print DATAA1 "\n";
      $x = 0;
      $y = $y+$dx;
    }

 close(DATAA1);

}

sub return_form
  {
      print $object->start_form();
      print $object->body('Your name is:', $object->b("<font color=blue>",$name)),
      $object->p,
      "<font color=black>";
      print $object->body('You have asked to solve the partial differential equation:'), $object->br,
	$object->b('<font color=red> u<sub>xx</sub> + u<sub>yy</sub> =', $k), $object->br,
	  $object->body('<font color=black> with boudary conditions:'),$object->br,
	    $object->b('<font color=blue> u(x,0) = ',$u_x_0), $object->br,
	      $object->b('u(0,y) = ',$u_0_y), $object->br,
		$object->b('u(x,5) = ',$u_x_5), $object->br,
		  $object->b('u(5,y) = ',$u_5_y), $object->br,
		    $object->p,
		      "<font color=black>";
      print $object->body('Here is the plot of the boundary conditions:'),
	$object->p;
      print $object->img({src=>"grid.gif"}),
	$object->p;
      print $object->body('(The green x',"'",'es are the given boundary points. The blue stars (<font color=blue>* <font color=black>) are the internal points where the values of <font color=red>'), $object->b('u(x,y) <font color=black>'), $object->body(' has to be calclulated.)');
      print $object->p;
      print $object->body('Here is the 3d plot of the boundary conditions:'),
	$object->p;
      print $object->img({src=>"grid3d.gif"}),
	$object->p;
      print $object->body('This is the result:'),
	$object->p,
	  $object->img({src=>"Simpson1.gif"});
      print $object->p;
      print $object->body('This is the Earth:'),
	$object->p,
	  $object->img({src=>"Earth.gif"});

    }


sub Gnuplot
  {
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
   set tit " This is the plot of u(x,y) "               #the title of the plot
        set grid
        set hidden3d
        set cntrparam levels 10
        set auto
        set data style lines
        set parametric
        set contour
      	set o "Simpson1.gif"                                                           #the name of the plot
        set terminal gif
	set ylabel "y"
        set xlabel "x"
        set zlabel "u(x,y)"
	splot [-1:6][-1:6][] "out.dat" u 1:2:5 w linespoints, "grid.dat" u 1:2:3 w l, "grid.dat" u 1:2:3 w p pt 2
gnuplot_Commands_done
    close(GNUPLOT);
  }

#        set label "u(0,y) = $u_0_y" at -0.8,2.5
#        set label "u(x,0) = $u_x_0" at  2.5,-0.3
#        set label "u(5,y) = $u_5_y" at  5.2,2.5
#        set label "u(x,5) = $u_x_5" at  2.5,5.2

sub Gnuplot_earth
  {
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
         set nokey
         set nozeroaxis
         set angles degrees
         set o "Earth.gif"
         set terminal gif
         set title "Thessaloniki on the Earth"
         set ticslevel 0
         set view 60,100
         set view ,,1.5
         set mapping spherical
         set parametric
         set samples 32
         set isosamples 20
         set urange [-90:90]
         set vrange [0:360]
         splot cos(u)*cos(v),cos(u)*sin(v),sin(u) with lines 5 6,'world.dat' u 1:2 w l lt 3 lw 2,'world.cor' u 1:2 w p pt 3 ps 3 lt 1
gnuplot_Commands_done
    close(GNUPLOT);
  }


sub Gnuplot_plegma
  {
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit " This is the grid of boundary conditions "               #the title of the plot
	unset key
      	set o "grid.gif"                                              #the name of the plot
	set terminal gif
	set ylabel "y"
	set xlabel "x"
        set label "u(0,y) = $u_0_y" at -1,2.5
        set label "u(x,0) = $u_x_0" at  2,-0.3
        set label "u(5,y) = $u_5_y" at  5.2,2.5
        set label "u(x,5) = $u_x_5" at  2,5.2
	plot [-2:7][-2:7] "grid.dat" u 1:2 w l, "grid.dat" u 1:2 w p pt 2, "grid1.dat" u 1:2 w p pt 3
gnuplot_Commands_done
    close(GNUPLOT);
  }

sub Gnuplot_3dplegma
  {
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit " This is the 3d grid of boundary conditions "               #the title of the plot
	unset key
        set grid
        set contour base
        set view 60,30
      	set o "grid3d.gif"                                                           #the name of the plot
	set terminal gif
	set ylabel "y"
	set xlabel "x"
        set zlabel "z"
        set label "u(0,y) = $u_0_y" at -0.8,2.5
        set label "u(x,0) = $u_x_0" at  2,-0.3
        set label "u(5,y) = $u_5_y" at  5.2,2.5
        set label "u(x,5) = $u_x_5" at  2,5.2
	splot [-1:6][-1:6] "grid.dat" u 1:2:3 w l, "grid.dat" u 1:2:3 w p pt 2
gnuplot_Commands_done
    close(GNUPLOT);
  }








#counts the visits and prints to the webpage
sub webtail
{
    print $object->p,
    $object->hr;
    $countfile = "cgicountR";
    $count = `cat $countfile`;
    chop($count);
    $count = $count + 1;
    open(INF,">$countfile");
    print INF "$count\n";
    close(INF);
    print $object->a({href=>"http://www.astro.auth.gr/~simos/cgi-bin/link.pl"}, 'Back to the Interactive Numerical Analysis page'); 
    print $object->hr;  
    print $object->p;
    #print the counter and contact e-mail address
    print $object->body("<font color = black>", "<font size=1.5>",'This web page has been visited: ',"<font color=red>",$count,"<font color=black>",'times');
    print $object->br;
    print $object->body("<font color=black>","<font size=1.5>",'If you have any comments or questions please contact: ');
    print $object->a({href=>'mailto:simos@astro.auth.gr'},'simos@astro.auth.gr');
    print $object->p;
    print $object->body("<!-- Start of StatCounter Code --><script type='text/javascript' language='javascript'>var sc_project=895250;var sc_invisible=0;var sc_partition=7;var sc_security='ccb97b32';</script><script type='text/javascript' language='javascript' src='http://www.statcounter.com/counter/counter.js'></script><noscript><a href='http://www.statcounter.com/' target='_blank'><img  src='http://c8.statcounter.com/counter.php?sc_project=895250&amp;java=0&amp;security=ccb97b32&amp;invisible=0' alt='web stats' border='0'></a> </noscript>
<!-- End of StatCounter Code -->");
}
